package com.jxl.mobile.charts
{
	import com.jxl.mobile.charts.vo.ChartVO;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Graphics;
	import flash.display.GraphicsPath;
	import flash.display.GraphicsPathCommand;
	import flash.display.GraphicsPathWinding;
	import flash.display.GraphicsSolidFill;
	import flash.display.IGraphicsData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.utils.getTimer;
	
	import mx.collections.ArrayCollection;
	import mx.core.UIComponent;
	
	import com.jxl.mobile.charts.vo.ChartVO;
	
	public class PlotChartBitmap extends UIComponent
	{
		
		[ArrayElementType("com.jxl.mobile.charts.vo.ChartVO")]
		private var _dataProvider:ArrayCollection;
		private var dataDirty:Boolean = false;
		
		private var _xMinimum:Number = 0;
		private var _xMaximum:Number = 100;
		private var _yMinimum:Number = 0;
		private var _yMaximum:Number = 100;
		private var axisDirty:Boolean = false;
		
		private var startTime:Number;
		private var elapsedTime:Number;
		private var currentDrawIndex:int;
		private var drawing:Boolean = false;
		private const MAX_TIME:Number = 10;
		private var timer:Sprite;
		
		private var testShape:Sprite;
		
		private var bitmap:Bitmap;
		private var bitmapData:BitmapData;
		private var pointShape:Shape;
		private var pointBitmap:Bitmap;
		private var destinationPoint:Point = new Point();
		private var zeroPointModule:Point = new Point(0, 0);
		
		[Bindable]
		public function get dataProvider():ArrayCollection { return _dataProvider; }
		public function set dataProvider(value:ArrayCollection):void
		{
			_dataProvider = value;
			dataDirty = true;
			invalidateProperties();
		}
		
		public function get xMinimum():Number { return _xMinimum; }
		public function set xMinimum(value:Number):void	
		{
			_xMinimum = value;
			axisDirty = true;
			invalidateProperties();
		}
		
		public function get xMaximum():Number { return _xMaximum; }
		public function set xMaximum(value:Number):void	
		{
			_xMaximum = value;
			axisDirty = true;
			invalidateProperties();
		}
		
		public function get yMinimum():Number { return _yMinimum; }
		public function set yMinimum(value:Number):void	
		{
			_yMinimum = value;
			axisDirty = true;
			invalidateProperties();
		}
		
		public function get yMaximum():Number { return _yMaximum; }
		public function set yMaximum(value:Number):void	
		{
			_yMaximum = value;
			axisDirty = true;
			invalidateProperties();
		}
		
		public function PlotChartBitmap()
		{
			super();
			
			width = 300;
			height = 300;
		}
		
		protected override function createChildren():void
		{
			super.createChildren();
			
			bitmapData = new BitmapData(width, height, false, 0);
			bitmap = new Bitmap(bitmapData, "auto", true);
			addChild(bitmap);
			
			testShape = new Sprite();
			
			pointShape = new Shape();
			pointShape.graphics.beginFill(0xFF0000);
			//pointShape.graphics.drawCircle(3, 3, 3);
			pointShape.graphics.drawRect(0, 0, 4, 4);
			pointShape.graphics.endFill();
			testShape.addChild(pointShape);
			
			/*
			var blueCircle:Shape = new Shape();
			blueCircle.graphics.beginFill(0x0000FF);
			blueCircle.graphics.drawCircle(3, 3, 3);
			blueCircle.graphics.lineStyle(2, 0xFF0000);
			blueCircle.graphics.drawRect(0, 0, 6, 6);
			blueCircle.graphics.endFill();
			addChild(blueCircle);
			blueCircle.x = 100;
			blueCircle.y = 100;
			*/
			
			var pointBitmapData:BitmapData = new BitmapData(4, 4, false, 0);
			pointBitmap = new Bitmap(pointBitmapData);
			pointBitmapData.draw(pointShape, new Matrix(), pointShape.transform.colorTransform);
			//addChild(pointBitmap);
			/*
			
			var copyBitmapData:BitmapData = new BitmapData(100, 100, true, 0x00000000);
			var copyBitmap:Bitmap = new Bitmap(copyBitmapData);
			addChild(copyBitmap);
			copyBitmap.x = 100;
			copyBitmap.y = 100;
			
			copyBitmapData.copyPixels(pointBitmap.bitmapData, pointBitmap.bitmapData.rect, new Point(0, 0));
			*/
			
		}
		
		protected override function commitProperties():void
		{
			super.commitProperties();
			
			if(dataDirty || axisDirty)
			{
				dataDirty = false;
				redraw();
			}
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth, unscaledHeight);
			
			var g:Graphics = graphics;
			g.clear();
			g.lineStyle(0, 0xFF0000);
			g.drawRect(0, 0, width, height);
			g.endFill();
		}
		
		private function stopDrawing():void
		{
			drawing = false;
			if(timer)
				timer.removeEventListener(Event.ENTER_FRAME, onTick);
		}
	
		public function redraw():void
		{
			Profile.start("PlotChartBitmap::redraw");
			
			if(drawing)
			{
				stopDrawing();
			}
			
			bitmap.bitmapData.fillRect(new Rectangle(0, 0, width, height), 0xFFFFFF);
			
			
			if(_dataProvider == null) return;
			
			// TODO: x & y min/max range check before attempting to redraw st00pid valuez
			
			const len:int = _dataProvider.length;
			if(len < 1) return;
			
			currentDrawIndex = 0;
			drawing = true;
			
			redrawNext();
		}
		
		private var pooledX:Number = 0;
		private var pooledY:Number = 0;
		
		private function redrawNext():void
		{
			//Debug.log("redrawNext, currentDrawIndex: " + currentDrawIndex + ", len: " + _dataProvider.length);
			if(_dataProvider.length)
			{
				startTime = getTimer();
				const xRange:Number = xMaximum - xMinimum;
				const yRange:Number = yMaximum - yMinimum;
				const len:int = _dataProvider.length;
				for(var index:int = currentDrawIndex; index < len; index++)
				{
					var chartVO:ChartVO = _dataProvider.getItemAt(index) as ChartVO;
					pooledX = width * (chartVO.xValue / xRange);
					pooledY = height * (chartVO.yValue / yRange);
					destinationPoint.x = pooledX;
					destinationPoint.y = pooledY;
					pointShape.x = pooledX;
					pointShape.y = pooledY;
					bitmapData.draw(testShape, null, testShape.transform.colorTransform);
					//bitmapData.copyPixels(pointBitmap.bitmapData, pointBitmap.bitmapData.rect, destinationPoint, pointBitmap.bitmapData, zeroPointModule, true);
					
					
					
					elapsedTime = getTimer() - startTime;
					if(elapsedTime > MAX_TIME)
					{
						currentDrawIndex = index + 1;
						waitAFrame();
						return;
					}
				}
				
				stopDrawing();
				Profile.stop("PlotChartBitmap::redraw");
			}
			else
			{
				stopDrawing();
				Profile.stop("PlotChartBitmap::redraw");
			}
		}
		
		private function waitAFrame():void
		{
			if(timer == null)
			{
				timer = new Sprite();
			}
			timer.addEventListener(Event.ENTER_FRAME, onTick);
		}
		
		private function onTick(event:Event):void
		{
			timer.removeEventListener(Event.ENTER_FRAME, onTick);
			if(drawing)
			{
				redrawNext();
			}
				
		}
		
	}
}