package com.jxl.mobile.charts.services
{
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IEventDispatcher;
	import flash.utils.getTimer;
	
	import com.jxl.mobile.charts.vo.ChartVO;
	
	[Event(name="completed", type="flash.events.Event")]
	public class GetChartVOsService extends EventDispatcher
	{
		private var startTime:Number;
		private var elapsedTime:Number;
		private const MAX_TIME:Number = 100;
		
		private var processing:Boolean = false;
		private var amount:uint;
		private var timer:Sprite;
		
		public var chartVOs:Array = [];
		
		public function GetChartVOsService()
		{
			super();
		}
		
		public function getChartVOs(amount:uint):void
		{
			if(processing)
			{
				stopProcessing();
			}
			
			processing = true;
			this.amount = amount;
			processNext();
		}
		
		private function processNext():void
		{
			//Debug.log("------------");
			//Debug.log("processNext, len: " + chartVOs.length);
			if(chartVOs.length < amount)
			{
				startTime = getTimer();
				var len:int = amount - chartVOs.length;
				//Debug.log("starting index: " + chartVOs.length + ", ending: " + amount);
				for(var index:int = chartVOs.length; index < amount; index++)
				{
					chartVOs[index] = getRandomChartVO();
					elapsedTime = getTimer() - startTime;
					if(elapsedTime >= MAX_TIME)
					{
						waitAFrame();
						return;
					}
				}
				//Debug.log("completed");
				completed();
			}
			else
			{
				//Debug.log("completed");
				completed();
			}
		}
		
		private function getRandomChartVO():ChartVO
		{
			return new ChartVO(null, getRandomNumber(0, 100), getRandomNumber(0, 100));
		}
		
		private var pooledResult:Number;
		
		private function getRandomNumber(min:Number, max:Number):Number
		{
			pooledResult = (Math.random() * max) - min;
			if(pooledResult < min)
				pooledResult = min;
			return pooledResult;
		}
		
		private function waitAFrame():void
		{
			if(timer == null)
			{
				timer = new Sprite();
			}
			timer.addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		
		private function stopProcessing():void
		{
			if(timer)
				timer.removeEventListener(Event.ENTER_FRAME, onEnterFrame);
			
			processing = false;
		}
		
		private function onEnterFrame(event:Event):void
		{
			timer.removeEventListener(Event.ENTER_FRAME, onEnterFrame);
			if(processing)
			{
				processNext();
			}
		}
		
		private function completed():void
		{
			dispatchEvent(new Event("completed"));
		}
	}
}